(function (exports, jsxRuntime, react) {
    'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || from);
    }

    function styleInject(css, ref) {
      if ( ref === void 0 ) ref = {};
      var insertAt = ref.insertAt;

      if (!css || typeof document === 'undefined') { return; }

      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';

      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }

      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z = ".table-responsive {\r\n    overflow-x: auto;\r\n}\r\n\r\n.table-caption {\r\n    display: block;\r\n    width: 100%;\r\n    text-align: left;\r\n    font-size: large;\r\n    font-weight: 600;\r\n    padding: 1rem 0 1rem 0;\r\n}\r\n\r\n.table-nodata{\r\n    text-align: center;\r\n    font-size: medium;\r\n    font-weight: 600;\r\n    padding: 1.5rem 0 1rem 0;\r\n}\r\n\r\n.table-dense{\r\n    padding: 0.2rem 0 0.2rem 0;\r\n    font-size: 0.8rem;\r\n}\r\n\r\n.table-striped:nth-child(even){\r\n    background-color: #f7f5f5d3;\r\n}\r\n\r\n.tr-onhover:hover{\r\n    background-color: #CBD5E1;\r\n}\r\n\r\n/* Elemet level CSS Styling so that class level supplied from JSX Can take default preference */\r\ntable {\r\n    border-collapse: collapse;\r\n    width: 100%;\r\n}\r\n\r\nth {\r\n    background-color: transparent;\r\n    text-align: left;\r\n    margin-left: 0;\r\n    padding: 0.475rem 0.5rem 0.475rem 0;\r\n}\r\n\r\n.th-inner{\r\n    display: flex;\r\n    align-items: center;\r\n    justify-content: space-between;\r\n    min-width: 10rem/* 160px */;\r\n}\r\n\r\n\r\ntr {\r\n    border-bottom: 1px solid #edeef0;\r\n}\r\n\r\ntr:last-child {\r\n    border-bottom:0;\r\n}\r\n\r\n\r\n\r\n\r\ntd{\r\n    padding: 0.875rem 0 0.875rem 0;\r\n    font-size: 0.85rem;\r\n}\r\n\r\n.button{\r\n    appearance: none;\r\n    color: inherit;\r\n    border:none;\r\n    font-family: inherit;\r\n    font-size: 0.9rem;\r\n    background-color: transparent;\r\n    padding: 0.375rem 0 0.375rem 0;\r\n    cursor: pointer;\r\n}\r\n\r\n.button:hover{\r\n    color: tomato;\r\n}\r\n\r\n.button:hover~.icon{\r\n    display: flex;\r\n}\r\n\r\n.button:focus{\r\n    outline: 2px solid transparent;\r\n    outline-offset: 2px;\r\n}\r\n\r\n.icon{\r\n    display: none;\r\n    flex-direction: column;\r\n    align-content: center;\r\n    justify-content: center;\r\n    color:rgb(182, 183, 196);\r\n    margin-right: 2rem;\r\n}\r\n\r\n.icon * {\r\n    padding: 0;\r\n    cursor: pointer;\r\n}\r\n.icon *:hover {\r\n    color: rgb(49, 47, 47);\r\n}\r\n\r\n.icon > *:first-child{\r\n    margin-bottom: -5px;\r\n}\r\n\r\n.icon-focus{\r\n    color:rgb(26, 25, 34);\r\n}\r\n\r\n.show{\r\n    display: flex !important;\r\n}\r\n\r\n\r\n\r\n/** PROGRESS PENDING */\r\n.progress-pending-wrapper{\r\n    width: 100%;\r\n    display: flex;\r\n    flex-direction: row;\r\n    justify-content: center;\r\n    margin: 1.2rem 0 1.2rem 0;\r\n}\r\n\r\n.progress-pending{\r\n    display: inline-flex;\r\n    align-items: center;\r\n    padding: 0.5rem 1rem 0.5rem 1rem;\r\n    background-color: rgb(160, 158, 158);\r\n    color: white;\r\n    font-size: large;\r\n    border-radius: 4px;\r\n    border:transparent;\r\n}\r\n\r\n.progress-pending-animation{\r\n    display: block;\r\n    width: 1.25rem;\r\n    height: 1.25rem;\r\n    color:white;\r\n    margin-right: .75rem;\r\n    animation: spin 1s linear infinite;\r\n}\r\n\r\n.progress-pending-circle{\r\n    opacity: .25;\r\n}\r\n\r\n.progress-pending-path{\r\n    opacity: .75;\r\n}\r\n@keyframes spin {\r\n  from {\r\n    transform: rotate(0deg);\r\n  }\r\n  to {\r\n    transform: rotate(360deg);\r\n  }\r\n}\r\n\r\n/** PAGINATION */\r\n.pagination{\r\n    margin-top: 1.5rem;\r\n    display: flex;\r\n    align-items: center;\r\n    justify-content: flex-end;\r\n}\r\n\r\n.pagination *:nth-child(n+2) {\r\n    --tw-space-x-reverse: 0;\r\n    margin-right: calc(2rem * var(--tw-space-x-reverse));\r\n    margin-left: calc(2rem * calc(1 - var(--tw-space-x-reverse)));\r\n}\r\n\r\n.pagination-dropdown{\r\n    min-width: 3rem;\r\n    display: flex;\r\n    align-items: center;\r\n}\r\n\r\n.pagination .pagination-dropdown p {\r\n    font-size: small;\r\n    font-weight: 500;\r\n    padding: 0 0.75rem 0 0;\r\n}\r\n\r\n.pagination .pagination-dropdown select {\r\n    padding: 0;\r\n    margin:0;\r\n    width: 3rem;\r\n}\r\n\r\n.pagination-rowsperpage{\r\n    font-size: small;\r\n    font-weight: 600;\r\n    color:rgb(18, 89, 221);\r\n}\r\n\r\n.pagination-buttonGroup{\r\n    display: flex;\r\n    align-items: center;\r\n}\r\n\r\n.pagination-button:disabled{\r\n    color: #c8c8c9;\r\n    pointer-events: none !important;\r\n}\r\n";
    styleInject(css_248z);

    var defaultOptions = {
        tableId: Math.floor(Math.random() * 1000).toString(),
        noDataMessage: 'No Data to Display',
        hideTableHeader: false,
        defaultSortAscending: true,
        pagination: false,
        showTableStriped: false,
        showRowPerPageDropdown: false,
        rowsPerPage: { option: [5, 10, 15, 20], defaultIndex: 0 }
    };
    var defaultCss = {
        caption: 'table-caption',
        tableDense: 'table-dense',
        tableResponsive: 'table-responsive',
        nodata: 'table-nodata',
        tableStriped: 'table-striped',
        highlightOnHoverClass: 'tr-onhover',
        headerElement: {
            header: '',
            headerInner: 'th-inner',
            headerButton: 'button',
            headerIcon: 'icon'
        },
        cellElement: {
            cellElelmentCss: ''
        },
        progressbar: {
            progressPendingWrapper: 'progress-pending-wrapper',
            progressPending: 'progress-pending',
            progressPendingAnimation: 'progress-pending-animation',
            progressPendingCircle: 'progress-pending-circle',
            progressPendingPath: 'progress-pending-path'
        },
        pagination: {
            pagination: 'pagination',
            paginationDropdown: 'pagination-dropdown',
            rowPerPageDisplay: 'pagination-rowsperpage',
            paginationButton: 'button pagination-button',
            paginationButtonGroup: 'pagination-buttonGroup',
        }
    };

    var Button = function (props) {
        return (jsxRuntime.jsx("button", __assign({ className: props.className, onClick: props.onClickHandler, onMouseOver: props.onMouseOverHandler, onMouseOut: props.onMouseOutHandler }, { children: props.children }), void 0));
    };

    var Icon = function (_a) {
        var name = _a.name, rest = __rest(_a, ["name"]);
        var ImportedIconRef = react.useRef(null);
        switch (name) {
            case 'sortAsc':
                return (jsxRuntime.jsx(jsxRuntime.Fragment, { children: jsxRuntime.jsx("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16", ref: ImportedIconRef }, rest, { children: jsxRuntime.jsx("path", { d: "M7.247 11.14L2.451 5.658C1.885 5.013 2.345 4 3.204 4h9.592a1 1 0 0 1 .753 1.659l-4.796 5.48a1 1 0 0 1-1.506 0z" }, void 0) }), void 0) }, void 0));
            case 'sortDesc':
                return (jsxRuntime.jsx(jsxRuntime.Fragment, { children: jsxRuntime.jsx("svg", __assign({ xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16", ref: ImportedIconRef }, rest, { children: jsxRuntime.jsx("path", { d: "M7.247 4.86l-4.796 5.481c-.566.647-.106 1.659.753 1.659h9.592a1 1 0 0 0 .753-1.659l-4.796-5.48a1 1 0 0 0-1.506 0z" }, void 0) }), void 0) }, void 0));
            default:
                return null;
        }
    };

    exports.Sorting = void 0;
    (function (Sorting) {
        Sorting[Sorting["ASC"] = 0] = "ASC";
        Sorting[Sorting["DESC"] = 1] = "DESC";
    })(exports.Sorting || (exports.Sorting = {}));

    var Header = function (props) {
        var _a = react.useState(props.item.isSorted), headerClicked = _a[0], setHeaderClicked = _a[1];
        var _b = react.useState(false), isHovered = _b[0], setIsHovered = _b[1];
        var handleOnClick = function (event) {
            setHeaderClicked(!headerClicked);
            props.onHeaderClick(!headerClicked, props.item, event);
        };
        return (jsxRuntime.jsx("th", __assign({ className: props.dense.isDense ? props.classNames.header + ' ' + props.dense.denseCss : props.classNames.header }, { children: jsxRuntime.jsxs("div", __assign({ className: props.classNames.headerInner }, { children: [jsxRuntime.jsx(Button, __assign({ className: props.classNames.headerButton, onClickHandler: handleOnClick, onMouseOutHandler: function () { setIsHovered(false); }, onMouseOverHandler: function () { setIsHovered(true); } }, { children: props.item.name }), void 0),
                    props.item.sortable && props.item.sortIcon && jsxRuntime.jsx(props.item.sortIcon, { props: props, isHeaderClicked: headerClicked, onSortClicked: props.onSortIconClick, prevDirection: props.item.sortDirection, isHovered: isHovered }, void 0),
                    props.item.sortable && !props.item.sortIcon && jsxRuntime.jsx(SortIcon, { props: props, isHeaderClicked: headerClicked, onSortClicked: props.onSortIconClick, prevDirection: props.item.sortDirection }, void 0)] }), void 0) }), void 0));
    };
    var SortIcon = function (_a) {
        var isHeaderClicked = _a.isHeaderClicked, onSortClicked = _a.onSortClicked, prevDirection = _a.prevDirection, props = _a.props;
        var iconRef = react.useRef(null);
        var _b = react.useState({ asc: '', desc: '' }), sortClass = _b[0], setSortClass = _b[1];
        react.useEffect(function () {
            var _a, _b;
            if (isHeaderClicked) {
                (_a = iconRef.current) === null || _a === void 0 ? void 0 : _a.classList.add("show");
                if (prevDirection) {
                    if (prevDirection === exports.Sorting.DESC) {
                        setSortClass({ asc: '', desc: 'icon-focus' });
                    }
                    else {
                        setSortClass({ asc: 'icon-focus', desc: '' });
                    }
                }
                else {
                    setSortClass({ asc: 'icon-focus', desc: '' });
                }
            }
            else {
                (_b = iconRef.current) === null || _b === void 0 ? void 0 : _b.classList.remove("show");
                setSortClass({ asc: '', desc: '' });
            }
        }, []);
        return (jsxRuntime.jsxs("div", __assign({ ref: iconRef, className: props.classNames.headerIcon }, { children: [jsxRuntime.jsx(Icon, { id: "sortDesc", name: "sortDesc", className: sortClass.desc, onClick: function (event) {
                        onSortClicked(exports.Sorting.DESC, props.item, event);
                    } }, void 0),
                jsxRuntime.jsx(Icon, { id: "sortAsc", name: "sortAsc", className: sortClass.asc, onClick: function (event) {
                        onSortClicked(exports.Sorting.ASC, props.item, event);
                    } }, void 0)] }), void 0));
    };

    var getClassesAsArray = function (classes) {
        return classes.split(" ");
    };
    var addClass = function (element, classArray) {
        classArray.forEach(function (item) {
            element.classList.add(item);
        });
    };
    var removeClass = function (element, classArray) {
        classArray.forEach(function (item) {
            element.classList.remove(item);
        });
    };

    var Cell = function (props) {
        var cell = react.useRef(null);
        react.useEffect(function () {
            if (props.dense.isDense && props.dense.denseCss) {
                if (props.dense.denseCss.length > 0) {
                    addClass(cell.current, getClassesAsArray(props.dense.denseCss));
                }
            }
            else {
                if (props.dense.denseCss) {
                    if (props.dense.denseCss.length > 0) {
                        removeClass(cell.current, getClassesAsArray(props.dense.denseCss));
                    }
                }
            }
        }, []);
        return (jsxRuntime.jsx("td", __assign({ ref: cell, className: props.classNames.cellElelmentCss, style: props.customCellStyle }, { children: props.children }), void 0));
    };

    var _this = undefined;
    var Row = function (props) {
        var row = react.useRef(null);
        var clickCount = react.useRef(0);
        var delay = 300;
        react.useEffect(function () {
            var _a;
            if (((_a = props.striped) === null || _a === void 0 ? void 0 : _a.isStriped) && props.striped.stripedCss) {
                if (props.striped.stripedCss.length > 0) {
                    addClass(row.current, getClassesAsArray(props.striped.stripedCss));
                }
            }
            else {
                if (props.striped.stripedCss) {
                    if (props.striped.stripedCss.length > 0) {
                        removeClass(row.current, getClassesAsArray(props.striped.stripedCss));
                    }
                }
            }
            if (props.onHover.isHoverRequired && props.onHover.onHoverCss) {
                if (props.onHover.onHoverCss.length > 0) ;
                addClass(row.current, getClassesAsArray(props.onHover.onHoverCss));
            }
            else {
                if (props.onHover.onHoverCss) {
                    if (props.onHover.onHoverCss.length > 0) {
                        removeClass(row.current, getClassesAsArray(props.onHover.onHoverCss));
                    }
                }
            }
        }, []);
        var handleOnClick = function (dataItem, event) {
            clickCount.current += 1;
            setTimeout(function () {
                if (clickCount.current === 1) {
                    props.rowSingleClicked(dataItem, event);
                }
                else if (clickCount.current === 2) {
                    props.rowDoubleClicked(dataItem, event);
                }
                clickCount.current = 0;
            }, delay);
        };
        var conditionalRowStyle = function (row) {
            var customStyle = {};
            if (props.customRowStyles) {
                props.customRowStyles.forEach(function (crs) {
                    if (!crs.when || typeof crs.when !== 'function') {
                        throw new Error('"when" is a delcrative function and must be defined in row formatting.');
                    }
                    if (!crs.style || typeof crs.style !== 'function') {
                        throw new Error('"style" is a delcrative function and must be defined in row formatting.');
                    }
                    if (crs.when(row)) {
                        customStyle = crs.style(row);
                    }
                });
            }
            return customStyle;
        };
        var conditionalCellStyle = function (value, customStyle) {
            var cellStyle = {};
            if (customStyle) {
                customStyle.forEach(function (cs) {
                    if (!cs.when || typeof cs.when !== 'function') {
                        throw new Error('"when" is a delcrative function and must be defined in custom cell formatting.');
                    }
                    if (!cs.style || typeof cs.style !== 'function') {
                        throw new Error('"style" is a delcrative function and must be defined in custom cell formatting.');
                    }
                    if (cs.when(value)) {
                        cellStyle = cs.style();
                    }
                });
            }
            return cellStyle;
            //displayValue={props.dataItem[item.selector!]}
        };
        return (jsxRuntime.jsx("tr", __assign({ className: props.classNames.rowElementCss, ref: row, onClick: handleOnClick.bind(_this, props.dataItem), style: conditionalRowStyle(props.dataItem) }, { children: props.header.map(function (item, index) {
                return (jsxRuntime.jsxs(Cell, __assign({ classNames: props.classNames.cellElementCss, dense: props.dense, customCellStyle: conditionalCellStyle(props.dataItem[item.selector], item.customCellStyles) }, { children: [!item.formatting && jsxRuntime.jsx(jsxRuntime.Fragment, { children: props.dataItem[item.selector] }, void 0),
                        item.formatting && jsxRuntime.jsx(item.formatting, { row: props.dataItem }, void 0)] }), index + item.selector));
            }) }), props.index));
    };

    var useSort = function (_a) {
        var sortArray = _a.sortArray, stortKey = _a.stortKey, _b = _a.sortDirection, sortDirection = _b === void 0 ? exports.Sorting.ASC : _b;
        switch (sortDirection) {
            case exports.Sorting.ASC:
                return sortArray.sort(function (a, b) {
                    if (a[stortKey] < b[stortKey])
                        return -1;
                    if (a[stortKey] > b[stortKey])
                        return 1;
                    return 0;
                });
            case exports.Sorting.DESC:
                return sortArray.sort(function (a, b) {
                    if (a[stortKey] < b[stortKey])
                        return 1;
                    if (a[stortKey] > b[stortKey])
                        return -1;
                    return 0;
                });
        }
    };

    var Progress = function (props) {
        return (jsxRuntime.jsx("div", __assign({ className: props.classNames.progressPendingWrapper }, { children: jsxRuntime.jsxs("button", __assign({ type: "button", className: props.classNames.progressPending, disabled: true }, { children: [jsxRuntime.jsxs("svg", __assign({ className: props.classNames.progressPendingAnimation, xmlns: "http://www.w3.org/2000/svg", fill: "none", viewBox: "0 0 24 24" }, { children: [jsxRuntime.jsx("circle", { className: props.classNames.progressPendingCircle, cx: "12", cy: "12", r: "10", stroke: "currentColor", strokeWidth: "4" }, void 0),
                            jsxRuntime.jsx("path", { className: props.classNames.progressPendingPath, fill: "currentColor", d: "M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z" }, void 0)] }), void 0), "Loading"] }), void 0) }), void 0));
    };

    var Pagination = function (props) {
        var _a, _b, _c;
        var currentSliceIndex = react.useRef({ start: 0, end: props.tableOptions.rowsPerPage.option[props.tableOptions.rowsPerPage.defaultIndex] });
        var _d = react.useState(function () {
            if (props.data.length === 0) {
                return { isLast: true, isFirst: true };
            }
            return { isLast: false, isFirst: true };
        }), pageState = _d[0], setPageState = _d[1];
        var handleCustomRowPerPageChange = function (currentSelectedIndex) {
            var selectedRowPerPage = props.tableOptions.rowsPerPage.option[currentSelectedIndex];
            var data = props.data;
            data = data.slice(0, selectedRowPerPage);
            currentSliceIndex.current = { start: 0, end: selectedRowPerPage };
            props.updateRowsPerPage(data, currentSelectedIndex);
        };
        var handleOnRowPerPageChange = function (event) {
            var rowPerPage = parseInt(event.target.value);
            var data = props.data;
            currentSliceIndex.current = { start: 0, end: rowPerPage };
            data = data.slice(0, rowPerPage);
            props.updateRowsPerPage(data, props.tableOptions.rowsPerPage.option.findIndex(function (item) { return item === rowPerPage; }));
        };
        var handlePageNavigationClick = function (action) {
            var rowPerPage = props.tableOptions.rowsPerPage.option[props.tableOptions.rowsPerPage.defaultIndex];
            var data = props.data;
            var startIndex = 0;
            var endIndex = 0;
            var remainder = data.length % rowPerPage;
            switch (action) {
                case 'first':
                    data = data.slice(0, rowPerPage);
                    currentSliceIndex.current = { start: 0, end: rowPerPage };
                    setPageState({ isFirst: true, isLast: false });
                    props.updateRowsPerPage(data, props.tableOptions.rowsPerPage.defaultIndex);
                    break;
                case 'previous':
                    startIndex = currentSliceIndex.current.start === 0 ? currentSliceIndex.current.start : currentSliceIndex.current.start - rowPerPage;
                    endIndex = startIndex === 0 ? rowPerPage : currentSliceIndex.current.end - rowPerPage;
                    if (currentSliceIndex.current.end === data.length) {
                        startIndex = currentSliceIndex.current.end - remainder - rowPerPage;
                        endIndex = currentSliceIndex.current.end - remainder;
                    }
                    startIndex === 0 ? setPageState({ isFirst: true, isLast: false }) : setPageState({ isFirst: false, isLast: false });
                    data = data.slice(startIndex, endIndex);
                    currentSliceIndex.current = { start: startIndex, end: endIndex };
                    props.updateRowsPerPage(data, props.tableOptions.rowsPerPage.defaultIndex);
                    break;
                case 'next':
                    startIndex = currentSliceIndex.current.start + rowPerPage;
                    endIndex = startIndex + rowPerPage <= data.length ? startIndex + rowPerPage : data.length;
                    endIndex === data.length ? setPageState({ isFirst: false, isLast: true }) : setPageState({ isFirst: false, isLast: false });
                    data = data.slice(startIndex, endIndex);
                    currentSliceIndex.current = { start: startIndex, end: endIndex };
                    props.updateRowsPerPage(data, props.tableOptions.rowsPerPage.defaultIndex);
                    break;
                case 'last':
                    startIndex = data.length - remainder;
                    endIndex = data.length;
                    data = data.slice(startIndex, endIndex);
                    currentSliceIndex.current = { start: startIndex, end: endIndex };
                    setPageState({ isFirst: false, isLast: true });
                    props.updateRowsPerPage(data, props.tableOptions.rowsPerPage.defaultIndex);
                    break;
            }
        };
        return (jsxRuntime.jsxs("div", __assign({ className: props.classNames.pagination }, { children: [props.tableOptions.customRowPerPageDropdown && props.tableOptions.showRowPerPageDropdown &&
                    jsxRuntime.jsx(props.tableOptions.customRowPerPageDropdown, { className: props.classNames.paginationDropdown, updateRows: handleCustomRowPerPageChange, rowsPerPage: props.tableOptions.rowsPerPage }, void 0),
                !props.tableOptions.customRowPerPageDropdown && props.tableOptions.showRowPerPageDropdown &&
                    jsxRuntime.jsxs("div", __assign({ className: props.classNames.paginationDropdown }, { children: [jsxRuntime.jsx("p", { children: "Rows per page" }, void 0),
                            jsxRuntime.jsx("select", __assign({ onChange: handleOnRowPerPageChange, defaultValue: (_a = props.tableOptions.rowsPerPage) === null || _a === void 0 ? void 0 : _a.option[(_b = props.tableOptions.rowsPerPage) === null || _b === void 0 ? void 0 : _b.defaultIndex] }, { children: (_c = props.tableOptions.rowsPerPage) === null || _c === void 0 ? void 0 : _c.option.map(function (number, index) { return jsxRuntime.jsx("option", { children: number }, 'rpp_' + index); }) }), void 0)] }), void 0),
                props.tableOptions.showRowsPerPage && jsxRuntime.jsxs("div", __assign({ className: props.classNames.rowPerPageDisplay }, { children: [currentSliceIndex.current.start, " - ", currentSliceIndex.current.end, " /", props.data.length] }), void 0),
                jsxRuntime.jsxs("div", __assign({ className: props.classNames.paginationButtonGroup }, { children: [jsxRuntime.jsxs("button", __assign({ className: props.classNames.paginationButton, disabled: pageState.isFirst, onClick: function () { handlePageNavigationClick('first'); } }, { children: [props.tableOptions.paginationIconFirstPage && jsxRuntime.jsx(props.tableOptions.paginationIconFirstPage, {}, void 0),
                                !props.tableOptions.paginationIconFirstPage && jsxRuntime.jsx(jsxRuntime.Fragment, { children: "First Page" }, void 0)] }), void 0),
                        jsxRuntime.jsxs("button", __assign({ className: props.classNames.paginationButton, disabled: pageState.isFirst, onClick: function () { handlePageNavigationClick('previous'); } }, { children: [props.tableOptions.paginationIconPrevious && jsxRuntime.jsx(props.tableOptions.paginationIconPrevious, {}, void 0),
                                !props.tableOptions.paginationIconPrevious && jsxRuntime.jsx(jsxRuntime.Fragment, { children: "Previous" }, void 0)] }), void 0),
                        jsxRuntime.jsxs("button", __assign({ className: props.classNames.paginationButton, disabled: pageState.isLast, onClick: function () { handlePageNavigationClick('next'); } }, { children: [props.tableOptions.paginationIconNext && jsxRuntime.jsx(props.tableOptions.paginationIconNext, {}, void 0),
                                !props.tableOptions.paginationIconNext && jsxRuntime.jsx(jsxRuntime.Fragment, { children: "Next" }, void 0)] }), void 0),
                        jsxRuntime.jsxs("button", __assign({ className: props.classNames.paginationButton, disabled: pageState.isLast, onClick: function () { handlePageNavigationClick('last'); } }, { children: [props.tableOptions.paginationIconLastPage && jsxRuntime.jsx(props.tableOptions.paginationIconLastPage, {}, void 0),
                                !props.tableOptions.paginationIconLastPage && jsxRuntime.jsx(jsxRuntime.Fragment, { children: "Last Page" }, void 0)] }), void 0)] }), void 0)] }), void 0));
    };

    var useDeepMerge = function (_a) {
        var source = _a.source, target = _a.target;
        function isObject(item) {
            return (item && typeof item === 'object' && !Array.isArray(item));
        }
        function mergeDeep(target) {
            var _a, _b;
            var sources = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                sources[_i - 1] = arguments[_i];
            }
            if (!sources.length)
                return target;
            var source = sources.shift();
            if (isObject(target) && isObject(source)) {
                for (var key in source) {
                    if (isObject(source[key])) {
                        if (!target[key])
                            Object.assign(target, (_a = {}, _a[key] = {}, _a));
                        mergeDeep(target[key], source[key]);
                    }
                    else {
                        Object.assign(target, (_b = {}, _b[key] = source[key], _b));
                    }
                }
            }
            return mergeDeep.apply(void 0, __spreadArray([target], sources));
        }
        return mergeDeep(target, source);
    };

    var DataTable = function (props) {
        var UniqueId = '_' + Math.random().toString(36).substr(2, 9);
        var currentSortedData = react.useRef([]);
        var _a = react.useState(defaultOptions), tableOptions = _a[0], setTableOptions = _a[1];
        var _b = react.useState(defaultCss), tableCss = _b[0], setTableCss = _b[1];
        var _c = react.useState([]), tableColumns = _c[0], setTableColumns = _c[1];
        var _d = react.useState([]), tableData = _d[0], setTableData = _d[1];
        /**
         * Set the table options by merging default options and props options to TableOptions.
         * Re-render the table if props.options changes
         */
        react.useEffect(function () {
            var newOptions = __assign(__assign({}, defaultOptions), props.options);
            setTableOptions(newOptions);
            //console.log('Options is fired', newOptions);
        }, [props.options]);
        /**
         * Set the table css by merging default css and props classnames to TableCss.
         * Re-render the table if props.classnames changes.
         */
        react.useEffect(function () {
            var target = JSON.parse(JSON.stringify(defaultCss));
            var newCss = useDeepMerge({ source: props.classNames, target: target });
            setTableCss(newCss);
            //console.log('CSS is fired');
        }, [props.classNames]);
        /**
         * Set Header Data after Initial Render.
         * Change table Header whenever the props changes
         */
        react.useEffect(function () {
            if (props.columns) {
                var newHeader = props.columns.map(function (item) { return (__assign(__assign({}, item), { isSorted: false })); });
                setTableColumns(newHeader);
            }
            //console.log('Header is fired');
        }, [props.columns]);
        /**
         * Set Table Data after Initial Render.
         * Change table data whenever the props changes for props.data
         */
        react.useEffect(function () {
            if (props.data) {
                var data = __spreadArray([], props.data);
                var newOptions = __assign(__assign({}, defaultOptions), props.options);
                if (newOptions.defaultSortHeader) {
                    var sortFunction = determineSortFunction();
                    if (newOptions.defaultSortAscending === undefined || newOptions.defaultSortAscending) {
                        data = sortFunction({ sortArray: data, stortKey: newOptions.defaultSortHeader, sortDirection: exports.Sorting.ASC });
                    }
                    else {
                        data = sortFunction({ sortArray: data, stortKey: newOptions.defaultSortHeader, sortDirection: exports.Sorting.DESC });
                    }
                }
                currentSortedData.current = data;
                if (newOptions.pagination) {
                    var rowPerPage = newOptions.rowsPerPage.option[newOptions.rowsPerPage.defaultIndex];
                    data = data.slice(0, rowPerPage);
                }
                setTableData(data);
            }
            //console.log('Data is fired');
        }, [props.data, props.options]);
        var determineSortFunction = function () {
            return tableOptions.customSortFunction ? tableOptions.customSortFunction : useSort;
        };
        var handleOnHeaderClick = function (isSortOpen, selectedItem, event) {
            var sortFunction = determineSortFunction();
            setTableColumns(function (prevState) {
                return prevState.map(function (item) {
                    if (item.selector === selectedItem.selector) {
                        return (__assign(__assign({}, item), { isSorted: isSortOpen, sortDirection: exports.Sorting.ASC }));
                    }
                    return (__assign(__assign({}, item), { isSorted: false, sortDirection: undefined }));
                });
            });
            var data = __spreadArray([], props.data);
            data = sortFunction({ sortArray: data, stortKey: selectedItem.selector, sortDirection: exports.Sorting.ASC });
            currentSortedData.current = data;
            if (tableOptions.pagination) {
                var rowPerPage = tableOptions.rowsPerPage.option[tableOptions.rowsPerPage.defaultIndex];
                data = data.slice(0, rowPerPage);
            }
            setTableData(data);
            if (tableOptions.onSort)
                tableOptions.onSort([], exports.Sorting.ASC, event);
        };
        var handleOnSortIconClick = function (sortDirection, headerItem) {
            //console.log('Sorting is called',sortDirection);
            var sortFunction = determineSortFunction();
            setTableColumns(function (prevState) {
                return prevState.map(function (item) {
                    if (item.selector === headerItem.selector) {
                        return (__assign(__assign({}, item), { sortDirection: sortDirection }));
                    }
                    return (__assign(__assign({}, item), { sortDirection: undefined }));
                });
            });
            var data = __spreadArray([], props.data);
            data = sortFunction({ sortArray: data, stortKey: headerItem.selector, sortDirection: sortDirection });
            currentSortedData.current = data;
            if (tableOptions.pagination) {
                var rowPerPage = tableOptions.rowsPerPage.option[tableOptions.rowsPerPage.defaultIndex];
                data = data.slice(0, rowPerPage);
            }
            setTableData(data);
        };
        var handleUpdateRowsPerPage = function (data, newIndex) {
            setTableData(data);
            setTableOptions(function (prevOptions) {
                prevOptions.rowsPerPage.defaultIndex = newIndex;
                return prevOptions;
            });
        };
        return (jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [tableOptions.showCaption &&
                    jsxRuntime.jsxs(jsxRuntime.Fragment, { children: [!tableOptions.customCaption && jsxRuntime.jsx("div", __assign({ className: tableCss.caption }, { children: tableOptions.caption }), void 0),
                            tableOptions.customCaption && jsxRuntime.jsx(tableOptions.customCaption, {}, void 0)] }, void 0),
                jsxRuntime.jsx("div", __assign({ className: tableOptions.responsive ? tableCss.tableResponsive + ' ' + tableCss.tableWrapper : tableCss.tableWrapper }, { children: jsxRuntime.jsxs("table", __assign({ id: tableOptions.tableId, className: tableCss.table }, { children: [!tableOptions.hideTableHeader &&
                                jsxRuntime.jsx("thead", __assign({ className: tableCss.tableHead }, { children: jsxRuntime.jsx("tr", __assign({ className: tableCss.tableHeaderRowElement }, { children: tableColumns.map(function (item, index) {
                                            return (jsxRuntime.jsx(Header, { item: item, classNames: tableCss.headerElement, onHeaderClick: handleOnHeaderClick, onSortIconClick: handleOnSortIconClick, dense: { isDense: tableOptions.dense, denseCss: tableCss.tableDense } }, UniqueId + '_' + index + item.selector));
                                        }) }), void 0) }), void 0),
                            jsxRuntime.jsxs("tbody", { children: [tableOptions.showProgressPending &&
                                        jsxRuntime.jsx("tr", { children: jsxRuntime.jsxs("td", __assign({ colSpan: tableColumns.length }, { children: [tableOptions.customProgressPendingComponent && jsxRuntime.jsx(tableOptions.customProgressPendingComponent, {}, void 0),
                                                    !tableOptions.customProgressPendingComponent && jsxRuntime.jsx(Progress, { classNames: tableCss.progressbar }, void 0)] }), void 0) }, void 0),
                                    !tableOptions.showProgressPending && tableData.length > 0 &&
                                        tableData.map(function (dataItem, index) {
                                            return jsxRuntime.jsx(Row, { header: tableColumns, dataItem: dataItem, index: UniqueId + index, classNames: { rowElementCss: tableCss.tableBodyRowElement, cellElementCss: tableCss.cellElement }, dense: { isDense: tableOptions.dense, denseCss: tableCss.tableDense }, striped: { isStriped: tableOptions.showTableStriped, stripedCss: tableCss.tableStriped }, onHover: { isHoverRequired: tableOptions.highlightOnHover, onHoverCss: tableCss.highlightOnHoverClass }, rowSingleClicked: tableOptions.onRowClicked, rowDoubleClicked: tableOptions.onRowDoubleClicked, customRowStyles: tableOptions.customRowStyles }, UniqueId + index);
                                        }),
                                    !tableOptions.showProgressPending && tableData.length === 0 && !tableOptions.noDataComponent &&
                                        jsxRuntime.jsx("tr", { children: jsxRuntime.jsx("td", __assign({ colSpan: tableColumns.length, className: tableCss.nodata }, { children: tableOptions.noDataMessage }), void 0) }, void 0),
                                    !tableOptions.showProgressPending && tableData.length === 0 && tableOptions.noDataComponent &&
                                        jsxRuntime.jsx(jsxRuntime.Fragment, { children: jsxRuntime.jsx(tableOptions.noDataComponent, {}, void 0) }, void 0)] }, void 0)] }), void 0) }), void 0),
                tableOptions.pagination && jsxRuntime.jsx(Pagination, { classNames: tableCss.pagination, tableOptions: tableOptions, data: __spreadArray([], currentSortedData.current), updateRowsPerPage: handleUpdateRowsPerPage }, void 0)] }, void 0));
    };

    exports.default = DataTable;

    Object.defineProperty(exports, '__esModule', { value: true });

}(this['@react-utility/datatable'] = this['@react-utility/datatable'] || {}, jsxRuntime, react));
